package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum FieldDataComboBoxType implements DatabaseEnum<String> {
	Autocomplete("autocomplete"),
	Wordlist("wordlist");
	private final String value;

	FieldDataComboBoxType(String value) {
		this.value = value;
	}

	@JsonValue
	public String getValue() {
		return value;
	}

	private static final Map<String, FieldDataComboBoxType> map = EnumUtils.getEnumValueMap(FieldDataComboBoxType.class);

	public static FieldDataComboBoxType of(String i) {
		return map.get(i);
	}
}
