package eu.eudat.commons.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum FieldDataInternalDmpEntryType implements DatabaseEnum<String> {
	Researchers("researchers"),
	Dmps("dmps"),
	Datasets("datasets");
	private final String value;

	FieldDataInternalDmpEntryType(String value) {
		this.value = value;
	}

	@JsonValue
	public String getValue() {
		return value;
	}

	private static final Map<String, FieldDataInternalDmpEntryType> map = EnumUtils.getEnumValueMap(FieldDataInternalDmpEntryType.class);

	public static FieldDataInternalDmpEntryType of(String i) {
		return map.get(i);
	}
}
