package eu.eudat.commons.enums.notification;

import com.fasterxml.jackson.annotation.JsonValue;
import eu.eudat.commons.enums.EnumUtils;
import eu.eudat.data.converters.enums.DatabaseEnum;

import java.util.Map;

public enum NotificationTrackingProcess implements DatabaseEnum<Short> {
    PENDING((short)0),
    PROCESSING((short)1),
    COMPLETED((short)2),
    ERROR((short)3),
    OMITTED((short)4);

    private final Short value;

    NotificationTrackingProcess(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, NotificationTrackingProcess> map = EnumUtils.getEnumValueMap(NotificationTrackingProcess.class);

    public static NotificationTrackingProcess of(Short i) {
        return map.get(i);
    }
}
