package eu.eudat.commons.types.descriptiontemplate.fielddata;

import eu.eudat.commons.enums.FieldDataComboBoxType;
import eu.eudat.commons.enums.FieldDataInternalDmpEntryType;
import eu.eudat.commons.enums.FieldType;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import java.util.HashMap;
import java.util.Map;

public class DatasetAutoCompleteDataEntity extends InternalDmpBaseDataEntity<DatasetAutoCompleteDataEntity> {
	private Boolean multiAutoComplete;

	public Boolean getMultiAutoComplete() {
		return multiAutoComplete;
	}
	public void setMultiAutoComplete(Boolean multiAutoComplete) {
		this.multiAutoComplete = multiAutoComplete;
	}

	@Override
	public FieldDataInternalDmpEntryType getFieldSubType() {
		return FieldDataInternalDmpEntryType.Datasets;
	}

	@Override
	public FieldType getFieldType() {
		return FieldType.INTERNAL_DMP_ENTRIES_DATASETS;
	}

	@Override
	public Element toXml(Document doc) {
		Element root = super.toXml(doc);
		root.setAttribute("multiAutoComplete", this.multiAutoComplete.toString());

		return root;
	}

	@Override
	public DatasetAutoCompleteDataEntity fromXml(Element item) {
		super.fromXml(item);
		this.multiAutoComplete = Boolean.parseBoolean(item.getAttribute("multiAutoComplete"));

		return this;
	}
}
