package eu.eudat.commons.types.descriptiontemplate.fielddata;

import eu.eudat.commons.enums.FieldType;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import java.util.HashMap;
import java.util.Map;

public class PublicationRepositoryDataEntity extends BaseFieldDataEntity<PublicationRepositoryDataEntity> {
    @Override
    public FieldType getFieldType() {
        return FieldType.PUB_REPOSITORIES;
    }
    
    private Boolean multiAutoComplete;

    public Boolean getMultiAutoComplete() {
        return multiAutoComplete;
    }

    public void setMultiAutoComplete(Boolean multiAutoComplete) {
        this.multiAutoComplete = multiAutoComplete;
    }
    
    @Override
    public Element toXml(Document doc) {
        Element root = super.toXml(doc);
        if (this.getMultiAutoComplete() != null) {
            root.setAttribute("multiAutoComplete", this.getMultiAutoComplete().toString());
        }
        return root;
    }

    @Override
    public PublicationRepositoryDataEntity fromXml(Element item) {
        super.fromXml(item);
        this.setMultiAutoComplete(Boolean.parseBoolean(item.getAttribute("multiAutoComplete")));
        return this;
    }
}
