package eu.eudat.commons.types.dmpblueprint;

import eu.eudat.commons.types.xml.XmlSerializable;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlAttribute;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import java.util.UUID;

@XmlAccessorType(XmlAccessType.FIELD)
public class DescriptionTemplateEntity implements XmlSerializable<DescriptionTemplateEntity> {

    @XmlAttribute(name="id")
    private UUID id;
    @XmlAttribute(name="descriptionTemplateId")
    private UUID descriptionTemplateId;
    @XmlAttribute(name="label")
    private String label;
    @XmlAttribute(name="minMultiplicity")
    private Integer minMultiplicity;
    @XmlAttribute(name="maxMultiplicity")
    private Integer maxMultiplicity;

    public UUID getId() {
        return id;
    }
    public void setId(UUID id) {
        this.id = id;
    }

    public UUID getDescriptionTemplateId() {
        return descriptionTemplateId;
    }
    public void setDescriptionTemplateId(UUID descriptionTemplateId) {
        this.descriptionTemplateId = descriptionTemplateId;
    }

    public String getLabel() {
        return label;
    }
    public void setLabel(String label) {
        this.label = label;
    }

    public Integer getMinMultiplicity() {
        return minMultiplicity;
    }
    public void setMinMultiplicity(Integer minMultiplicity) {
        this.minMultiplicity = minMultiplicity;
    }

    public Integer getMaxMultiplicity() {
        return maxMultiplicity;
    }
    public void setMaxMultiplicity(Integer maxMultiplicity) {
        this.maxMultiplicity = maxMultiplicity;
    }

    @Override
    public Element toXml(Document doc) {
        Element rootElement = doc.createElement("descriptionTemplate");
        rootElement.setAttribute("id", this.getId().toString());
        rootElement.setAttribute("descriptionTemplateId", this.getDescriptionTemplateId().toString());
        rootElement.setAttribute("label", this.label);
        rootElement.setAttribute("minMultiplicity", String.valueOf(this.minMultiplicity));
        rootElement.setAttribute("maxMultiplicity", String.valueOf(this.maxMultiplicity));
        return rootElement;
    }

    @Override
    public DescriptionTemplateEntity fromXml(Element item) {
        this.id = UUID.fromString(item.getAttribute("id"));
        this.descriptionTemplateId = UUID.fromString(item.getAttribute("descriptionTemplateId"));
        this.label = item.getAttribute("label");
        this.minMultiplicity = item.hasAttribute("minMultiplicity") && !item.getAttribute("minMultiplicity").equals("null") ? Integer.parseInt(item.getAttribute("minMultiplicity")) : null;
        this.maxMultiplicity = item.hasAttribute("maxMultiplicity") && !item.getAttribute("minMultiplicity").equals("null") ? Integer.parseInt(item.getAttribute("maxMultiplicity")) : null;
        return this;
    }
}
