package eu.eudat.commons.types.dmpblueprint;

import eu.eudat.commons.enums.DmpBlueprintExtraFieldDataType;
import eu.eudat.commons.enums.DmpBlueprintFieldCategory;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlAttribute;
import org.w3c.dom.Element;

@XmlAccessorType(XmlAccessType.FIELD)
public class ExtraFieldEntity extends FieldEntity {

    @XmlAttribute(name="type")
    private DmpBlueprintExtraFieldDataType type;

    public DmpBlueprintExtraFieldDataType getType() {
        return type;
    }
    public void setType(DmpBlueprintExtraFieldDataType type) {
        this.type = type;
    }

    @Override
    public Element appendXmlChild(Element rootElement) {
        rootElement.setAttribute("type", String.valueOf(this.type.getValue()));
        return rootElement;
    }

    @Override
    public ExtraFieldEntity fromXmlChild(Element item) {
        this.type = DmpBlueprintExtraFieldDataType.of(Short.parseShort(item.getAttribute("type")));
        this.setCategory(DmpBlueprintFieldCategory.Extra);
        return this;
    }
}
