package eu.eudat.commons.types.dmpblueprint;

import eu.eudat.commons.enums.DmpBlueprintFieldCategory;
import eu.eudat.commons.enums.DmpBlueprintSystemFieldType;
import eu.eudat.commons.types.xml.XmlSerializable;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlAttribute;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import java.util.UUID;

@XmlAccessorType(XmlAccessType.FIELD)
public class SystemFieldEntity extends FieldEntity {

    @XmlAttribute(name="type")
    private DmpBlueprintSystemFieldType type;

    public DmpBlueprintSystemFieldType getType() {
        return type;
    }
    public void setType(DmpBlueprintSystemFieldType type) {
        this.type = type;
    }

    @Override
    public Element appendXmlChild(Element rootElement) {
        rootElement.setAttribute("type", String.valueOf(this.type.getValue()));
        return rootElement;
    }

    @Override
    public SystemFieldEntity fromXmlChild(Element item) {
        this.type = DmpBlueprintSystemFieldType.of(Short.parseShort(item.getAttribute("type")));
        this.setCategory(DmpBlueprintFieldCategory.System);
        return this;
    }
}
