package eu.eudat.commons.validation;

import java.util.ArrayList;
import java.util.List;

public class ValidationResult {
	private final List<ValidationFailure> errors;

	public ValidationResult() {
		this.errors = new ArrayList<>();
	}

	public Boolean isValid() {
		return this.errors.isEmpty();
	} 
	public ValidationResult add(ValidationFailure failure) {
		if (failure != null) {
			errors.add(failure);
		}
		return this;
	}

	public ValidationResult addAll(List<ValidationFailure> failures) {
		if (failures != null) {
			errors.addAll(failures);
		}
		return this;
	}

	public List<ValidationFailure> getErrors() {
		return errors;
	}
}

