package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.DatasetAutoCompleteDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.DatasetAutoCompleteData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class DatasetAutoCompleteDataBuilder extends BaseFieldDataBuilder<DatasetAutoCompleteData, DatasetAutoCompleteDataEntity> {

	@Autowired
	public DatasetAutoCompleteDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(DatasetAutoCompleteDataBuilder.class)));
	}

	protected DatasetAutoCompleteData getInstance() {
		return new DatasetAutoCompleteData();
	}

	@Override
	protected void buildChild(FieldSet fields, DatasetAutoCompleteDataEntity d, DatasetAutoCompleteData m) {
		if (fields.hasField(this.asIndexer(DatasetAutoCompleteData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
