package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.DmpAutoCompleteDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.DmpAutoCompleteData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class DmpAutoCompleteDataBuilder extends BaseFieldDataBuilder<DmpAutoCompleteData, DmpAutoCompleteDataEntity> {

	@Autowired
	public DmpAutoCompleteDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(DmpAutoCompleteDataBuilder.class)));
	}

	protected DmpAutoCompleteData getInstance() {
		return new DmpAutoCompleteData();
	}

	@Override
	protected void buildChild(FieldSet fields, DmpAutoCompleteDataEntity d, DmpAutoCompleteData m) {
		if (fields.hasField(this.asIndexer(DmpAutoCompleteData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
		
	}
}
