package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.DataRepositoryDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.JournalRepositoryDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.DataRepositoryData;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.JournalRepositoryData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class JournalRepositoryDataBuilder extends BaseFieldDataBuilder<JournalRepositoryData, JournalRepositoryDataEntity> {

	@Autowired
	public JournalRepositoryDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(JournalRepositoryDataBuilder.class)));
	}

	protected JournalRepositoryData getInstance() {
		return new JournalRepositoryData();
	}

	@Override
	protected void buildChild(FieldSet fields, JournalRepositoryDataEntity d, JournalRepositoryData m) {
		if (fields.hasField(this.asIndexer(JournalRepositoryData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
