package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.LicenseDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.ComboBoxOption;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.LicenseData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class LicenseDataBuilder extends BaseFieldDataBuilder<LicenseData, LicenseDataEntity> {

	@Autowired
	public LicenseDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(LicenseDataBuilder.class)));
	}

	protected LicenseData getInstance() {
		return new LicenseData();
	}
	@Override
	protected void buildChild(FieldSet fields, LicenseDataEntity d, LicenseData m) {
		if (fields.hasField(this.asIndexer(LicenseData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
