package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.OrganizationDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.OrganizationData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class OrganizationDataBuilder extends BaseFieldDataBuilder<OrganizationData, OrganizationDataEntity> {

	@Autowired
	public OrganizationDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(OrganizationDataBuilder.class)));
	}

	protected OrganizationData getInstance() {
		return new OrganizationData();
	}
	@Override
	protected void buildChild(FieldSet fields, OrganizationDataEntity d, OrganizationData m) {
		if (fields.hasField(this.asIndexer(OrganizationData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
