package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.PublicationDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.PublicationData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class PublicationDataBuilder extends BaseFieldDataBuilder<PublicationData, PublicationDataEntity> {

	@Autowired
	public PublicationDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(PublicationDataBuilder.class)));
	}

	protected PublicationData getInstance() {
		return new PublicationData();
	}
	@Override
	protected void buildChild(FieldSet fields, PublicationDataEntity d, PublicationData m) {
		if (fields.hasField(this.asIndexer(PublicationData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
