package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.RegistryDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.RegistryData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class RegistryDataBuilder extends BaseFieldDataBuilder<RegistryData, RegistryDataEntity> {

	@Autowired
	public RegistryDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(RegistryDataBuilder.class)));
	}

	protected RegistryData getInstance() {
		return new RegistryData();
	}
	@Override
	protected void buildChild(FieldSet fields, RegistryDataEntity d, RegistryData m) {
		if (fields.hasField(this.asIndexer(RegistryData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
