package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.ResearcherDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.ResearcherData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class ResearcherDataBuilder extends BaseFieldDataBuilder<ResearcherData, ResearcherDataEntity> {

	@Autowired
	public ResearcherDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(ResearcherDataBuilder.class)));
	}

	protected ResearcherData getInstance() {
		return new ResearcherData();
	}
	@Override
	protected void buildChild(FieldSet fields, ResearcherDataEntity d, ResearcherData m) {
		if (fields.hasField(this.asIndexer(ResearcherData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
