package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.ServiceDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.ServiceData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class ServiceDataBuilder extends BaseFieldDataBuilder<ServiceData, ServiceDataEntity> {

	@Autowired
	public ServiceDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(ServiceDataBuilder.class)));
	}

	protected ServiceData getInstance() {
		return new ServiceData();
	}
	@Override
	protected void buildChild(FieldSet fields, ServiceDataEntity d, ServiceData m) {
		if (fields.hasField(this.asIndexer(ServiceData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
