package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.TaxonomyDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.TaxonomyData;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class TaxonomyDataBuilder extends BaseFieldDataBuilder<TaxonomyData, TaxonomyDataEntity> {

	@Autowired
	public TaxonomyDataBuilder(ConventionService conventionService) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(TaxonomyDataBuilder.class)));
	}

	protected TaxonomyData getInstance() {
		return new TaxonomyData();
	}
	@Override
	protected void buildChild(FieldSet fields, TaxonomyDataEntity d, TaxonomyData m) {
		if (fields.hasField(this.asIndexer(TaxonomyData._multiAutoComplete))) m.setMultiAutoComplete(d.getMultiAutoComplete());
	}
}
