package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.UploadDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.UploadData;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class UploadDataBuilder extends BaseFieldDataBuilder<UploadData, UploadDataEntity> {
	private final BuilderFactory builderFactory;

	@Autowired
	public UploadDataBuilder(ConventionService conventionService, BuilderFactory builderFactory) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(UploadDataBuilder.class)));
		this.builderFactory = builderFactory;
	}

	protected UploadData getInstance() {
		return new UploadData();
	}
	@Override
	protected void buildChild(FieldSet fields, UploadDataEntity d, UploadData m) {
		FieldSet typesFields = fields.extractPrefixed(this.asPrefix(UploadData._types));
		if (!typesFields.isEmpty() && d.getTypes() != null) m.setTypes(this.builderFactory.builder(UploadOptionBuilder.class).build(typesFields, d.getTypes()));
	}
}
