package eu.eudat.model.builder.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.types.descriptiontemplate.fielddata.WordListDataEntity;
import eu.eudat.convention.ConventionService;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.WordListData;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.logging.LoggerService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
@Scope(value = ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class WordListDataBuilder extends BaseFieldDataBuilder<WordListData, WordListDataEntity> {
	private final BuilderFactory builderFactory;
	@Autowired
	public WordListDataBuilder(ConventionService conventionService, BuilderFactory builderFactory) {
		super(conventionService, new LoggerService(LoggerFactory.getLogger(WordListDataBuilder.class)));
		this.builderFactory = builderFactory;
	}

	@Override
	protected WordListData getInstance() {
		return new WordListData();
	}

	@Override
	protected void buildChild(FieldSet fields, WordListDataEntity d, WordListData m) {
		FieldSet optionsFields = fields.extractPrefixed(this.asPrefix(WordListData._options));
		if (fields.hasField(this.asIndexer(WordListData._multiList))) m.setMultiList(d.getMultiList());
		if (!optionsFields.isEmpty() && d.getOptions() != null) m.setOptions(this.builderFactory.builder(ComboBoxOptionBuilder.class).authorize(this.authorize).build(optionsFields, d.getOptions()));
		
	}
}
