package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.ValidatorFactory;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class BooleanDecisionDataPersist extends BaseFieldDataPersist {

    @Component(BooleanDecisionPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class BooleanDecisionPersistValidator extends BaseFieldDataPersistValidator<BooleanDecisionDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.BooleanDecisionPersistValidator";

        private final ValidatorFactory validatorFactory;

        protected BooleanDecisionPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource, ValidatorFactory validatorFactory) {
            super(conventionService, errors, messageSource);
            this.validatorFactory = validatorFactory;
        }

        @Override
        protected Class<BooleanDecisionDataPersist> modelClass() {
            return BooleanDecisionDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(BooleanDecisionDataPersist item) {
            return getBaseSpecifications(item);
        }
    }

}
