package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.ValidatorFactory;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class CheckBoxDataPersist extends BaseFieldDataPersist {

    @Component(CheckBoxDataPersist.CheckBoxDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class CheckBoxDataPersistValidator extends BaseFieldDataPersistValidator<CheckBoxDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.CheckBoxDataPersistValidator";

        protected CheckBoxDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<CheckBoxDataPersist> modelClass() {
            return CheckBoxDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(CheckBoxDataPersist item) {
            return getBaseSpecifications(item);
        }
    }

}
