package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class CurrencyDataPersist extends BaseFieldDataPersist {

    @Component(CurrencyDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class CurrencyDataPersistValidator extends BaseFieldDataPersistValidator<CurrencyDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.CurrencyDataPersistValidator";

        protected CurrencyDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<CurrencyDataPersist> modelClass() {
            return CurrencyDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(CurrencyDataPersist item) {
            return getBaseSpecifications(item);
        }

    }
}
