package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class DatasetIdentifierDataPersist extends BaseFieldDataPersist {

    @Component(DatasetIdentifierDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class DatasetIdentifierDataPersistValidator extends BaseFieldDataPersistValidator<DatasetIdentifierDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.DatasetIdentifierDataPersistValidator";

        protected DatasetIdentifierDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<DatasetIdentifierDataPersist> modelClass() {
            return DatasetIdentifierDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(DatasetIdentifierDataPersist item) {
            return getBaseSpecifications(item);
        }
    }

}
