package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.ValidatorFactory;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class DatePickerDataPersist extends BaseFieldDataPersist {

    @Component(DatePickerDataPersist.DatePickerDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class DatePickerDataPersistValidator extends BaseFieldDataPersistValidator<DatePickerDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.DatePickerDataPersistValidator";

        private final ValidatorFactory validatorFactory;

        protected DatePickerDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource, ValidatorFactory validatorFactory) {
            super(conventionService, errors, messageSource);
            this.validatorFactory = validatorFactory;
        }

        @Override
        protected Class<DatePickerDataPersist> modelClass() {
            return DatePickerDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(DatePickerDataPersist item) {
            return getBaseSpecifications(item);
        }
    }

}
