package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.enums.FieldDataExternalDatasetType;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;

public class ExternalDatasetDataPersist extends BaseFieldDataPersist {

    private Boolean multiAutoComplete = null;

    public static final String _multiAutoComplete = "multiAutoComplete";

    private FieldDataExternalDatasetType type;

    public static final String _type = "type";

    public Boolean getMultiAutoComplete() {
        return multiAutoComplete;
    }

    public void setMultiAutoComplete(Boolean multiAutoComplete) {
        this.multiAutoComplete = multiAutoComplete;
    }

    public FieldDataExternalDatasetType getType() {
        return type;
    }

    public void setType(FieldDataExternalDatasetType type) {
        this.type = type;
    }

    @Component(ExternalDatasetDataPersist.ExternalDatasetDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class ExternalDatasetDataPersistValidator extends BaseFieldDataPersistValidator<ExternalDatasetDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.ExternalDatasetDataPersistValidator";

        protected ExternalDatasetDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<ExternalDatasetDataPersist> modelClass() {
            return ExternalDatasetDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(ExternalDatasetDataPersist item) {
            List<Specification> specifications = getBaseSpecifications(item);
            specifications.addAll(Arrays.asList(
                    this.spec()
                            .must(() -> !this.isNull(item.getMultiAutoComplete()))
                            .failOn(ExternalDatasetDataPersist._multiAutoComplete).failWith(messageSource.getMessage("Validation_Required", new Object[]{ExternalDatasetDataPersist._multiAutoComplete}, LocaleContextHolder.getLocale())),
                    this.spec()
                            .must(() -> !this.isNull(item.getType()))
                            .failOn(ExternalDatasetDataPersist._type).failWith(messageSource.getMessage("Validation_Required", new Object[]{ExternalDatasetDataPersist._type}, LocaleContextHolder.getLocale()))

            ));
            return specifications;
        }
    }

}
