package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class FreeTextDataPersist extends BaseFieldDataPersist {

    @Component(FreeTextDataPersist.FreeTextDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class FreeTextDataPersistValidator extends BaseFieldDataPersistValidator<FreeTextDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.FreeTextDataPersistValidator";

        protected FreeTextDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<FreeTextDataPersist> modelClass() {
            return FreeTextDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(FreeTextDataPersist item) {
            return getBaseSpecifications(item);
        }
    }

}
