package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Component;

import java.util.List;

public class PublicationDataPersist extends BaseFieldDataPersist {

    private Boolean multiAutoComplete;

    public static final String _multiAutoComplete = "multiAutoComplete";

    public Boolean getMultiAutoComplete() {
        return multiAutoComplete;
    }

    public void setMultiAutoComplete(Boolean multiAutoComplete) {
        this.multiAutoComplete = multiAutoComplete;
    }

    @Component(PublicationDataPersist.PublicationDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class PublicationDataPersistValidator extends BaseFieldDataPersistValidator<PublicationDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.PublicationDataPersistValidator";

        protected PublicationDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<PublicationDataPersist> modelClass() {
            return PublicationDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(PublicationDataPersist item) {
            List<Specification> specifications = getBaseSpecifications(item);
            specifications.add(
                    this.spec()
                            .must(() -> !this.isNull(item.getMultiAutoComplete()))
                            .failOn(PublicationDataPersist._multiAutoComplete).failWith(messageSource.getMessage("Validation_Required", new Object[]{PublicationDataPersist._multiAutoComplete}, LocaleContextHolder.getLocale()))
            );
            return specifications;
        }
    }

}
