package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Component;

import java.util.List;

public class ResearcherAutoCompleteDataPersist extends BaseFieldDataPersist {

	private Boolean multiAutoComplete = null;

	public static final String _multiAutoComplete = "multiAutoComplete";

	public Boolean getMultiAutoComplete() {
		return multiAutoComplete;
	}
	public void setMultiAutoComplete(Boolean multiAutoComplete) {
		this.multiAutoComplete = multiAutoComplete;
	}

	@Component(ResearcherAutoCompleteDataPersistValidator.ValidatorName)
	@Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
	public static class ResearcherAutoCompleteDataPersistValidator extends BaseFieldDataPersistValidator<ResearcherAutoCompleteDataPersist> {

		public static final String ValidatorName = "DescriptionTemplate.ResearcherAutoCompleteDataPersistValidator";

		protected ResearcherAutoCompleteDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
			super(conventionService, errors, messageSource);
		}

		@Override
		protected Class<ResearcherAutoCompleteDataPersist> modelClass() {
			return ResearcherAutoCompleteDataPersist.class;
		}

		@Override
		protected List<Specification> specifications(ResearcherAutoCompleteDataPersist item) {
			List<Specification> specifications = getBaseSpecifications(item);
			specifications.add(
					this.spec()
							.must(() -> !this.isNull(item.getMultiAutoComplete()))
							.failOn(ResearcherAutoCompleteDataPersist._multiAutoComplete).failWith(messageSource.getMessage("Validation_Required", new Object[]{ResearcherAutoCompleteDataPersist._multiAutoComplete}, LocaleContextHolder.getLocale()))
			);
			return specifications;
		}
	}

}
