package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class RichTextAreaDataPersist extends BaseFieldDataPersist {

    @Component(RichTextAreaDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class RichTextAreaDataPersistValidator extends BaseFieldDataPersistValidator<RichTextAreaDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.RichTextAreaDataPersistValidator";

        protected RichTextAreaDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<RichTextAreaDataPersist> modelClass() {
            return RichTextAreaDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(RichTextAreaDataPersist item) {
            return getBaseSpecifications(item);
        }
    }

}
