package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class TagDataPersist extends BaseFieldDataPersist {

    @Component(TagDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class TagDataPersistValidator extends BaseFieldDataPersistValidator<TagDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.TagDataPersistValidator";

        protected TagDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<TagDataPersist> modelClass() {
            return TagDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(TagDataPersist item) {
            return getBaseSpecifications(item);
        }
    }

}
