package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class TextAreaDataPersist extends BaseFieldDataPersist {

    @Component(TextAreaDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class TextAreaDataPersistValidator extends BaseFieldDataPersistValidator<TextAreaDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.TextAreaDataPersistValidator";

        protected TextAreaDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<TextAreaDataPersist> modelClass() {
            return TextAreaDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(TextAreaDataPersist item) {
            return getBaseSpecifications(item);
        }
    }
    
}
