package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class ValidationDataPersist extends BaseFieldDataPersist {

    @Component(ValidationDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class ValidationDataPersistValidator extends BaseFieldDataPersistValidator<ValidationDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.ValidationDataPersistValidator";

        protected ValidationDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource) {
            super(conventionService, errors, messageSource);
        }

        @Override
        protected Class<ValidationDataPersist> modelClass() {
            return ValidationDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(ValidationDataPersist item) {
            return getBaseSpecifications(item);
        }
    }

}
