package eu.eudat.model.persist.descriptiontemplatedefinition.fielddata;

import eu.eudat.commons.validation.ValidatorFactory;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;

public class WordListDataPersist extends BaseFieldDataPersist {

    private List<ComboBoxOptionPersist> options = null;

    public static final String _options = "options";

    private Boolean multiList = null;

    public static final String _multiList = "multiList";

    public List<ComboBoxOptionPersist> getOptions() {
        return options;
    }

    public void setOptions(List<ComboBoxOptionPersist> options) {
        this.options = options;
    }

    public Boolean getMultiList() {
        return multiList;
    }

    public void setMultiList(Boolean multiList) {
        this.multiList = multiList;
    }

    @Component(WordListDataPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class WordListDataPersistValidator extends BaseFieldDataPersistValidator<WordListDataPersist> {

        public static final String ValidatorName = "DescriptionTemplate.WordListDataPersistValidator";

        private final ValidatorFactory validatorFactory;

        protected WordListDataPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource, ValidatorFactory validatorFactory) {
            super(conventionService, errors, messageSource);
            this.validatorFactory = validatorFactory;
        }

        @Override
        protected Class<WordListDataPersist> modelClass() {
            return WordListDataPersist.class;
        }

        @Override
        protected List<Specification> specifications(WordListDataPersist item) {
            List<Specification> specifications = getBaseSpecifications(item);
            specifications.addAll(Arrays.asList(
                    this.spec()
                            .must(() -> !this.isNull(item.getMultiList()))
                            .failOn(WordListDataPersist._multiList).failWith(messageSource.getMessage("Validation_Required", new Object[]{WordListDataPersist._multiList}, LocaleContextHolder.getLocale())),

                    this.spec()
                            .must(() -> !this.isNull(item.getOptions()))
                            .failOn(WordListDataPersist._options).failWith(messageSource.getMessage("Validation_Required", new Object[]{WordListDataPersist._options}, LocaleContextHolder.getLocale())),
                    this.navSpec()
                            .iff(() -> !this.isNull(item.getOptions()))
                            .on(WordListDataPersist._options)
                            .over(item.getOptions())
                            .using(() -> this.validatorFactory.validator(ComboBoxOptionPersist.ComboBoxOptionPersistValidator.class))
            ));
            return specifications;
        }
    }

}
