package eu.eudat.model.persist.dmpproperties;

import eu.eudat.commons.validation.BaseValidator;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

public class DmpBlueprintValuePersist {

    private String fieldId;

    private String fieldName;

    private String fieldValue;

    public String getFieldId() {
        return fieldId;
    }

    public void setFieldId(String fieldId) {
        this.fieldId = fieldId;
    }

    public String getFieldName() {
        return fieldName;
    }

    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }

    public String getFieldValue() {
        return fieldValue;
    }

    public void setFieldValue(String fieldValue) {
        this.fieldValue = fieldValue;
    }

    @Component(DmpBlueprintValuePersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class DmpBlueprintValuePersistValidator extends BaseValidator<DmpBlueprintValuePersist> {

        public static final String ValidatorName = "DmpBlueprintValuePersistValidator";

        protected DmpBlueprintValuePersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors) {
            super(conventionService, errors);
        }

        @Override
        protected Class<DmpBlueprintValuePersist> modelClass() {
            return DmpBlueprintValuePersist.class;
        }

        @Override
        protected List<Specification> specifications(DmpBlueprintValuePersist item) {
            return new ArrayList<>();
        }
    }

}
