package eu.eudat.model.persist.dmpproperties;

import eu.eudat.commons.validation.BaseValidator;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

public class DmpContactPersist {

    String userId;

    String firstName;

    String lastName;

    String email;

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Component(DmpContactPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class DmpContactPersistValidator extends BaseValidator<DmpContactPersist> {

        public static final String ValidatorName = "DmpContactPersistValidator";

        protected DmpContactPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors) {
            super(conventionService, errors);
        }

        @Override
        protected Class<DmpContactPersist> modelClass() {
            return DmpContactPersist.class;
        }

        @Override
        protected List<Specification> specifications(DmpContactPersist item) {
            return new ArrayList<>();
        }
    }

}
