package eu.eudat.model.persist.referencetypedefinition;

import eu.eudat.commons.validation.BaseValidator;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import jakarta.xml.bind.annotation.XmlElement;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

public class QueryConfigPersist {

    private String condition;

    private String separator;

    private String value;

    private Integer ordinal;

    public String getCondition() {
        return condition;
    }

    @XmlElement(name = "condition")
    public void setCondition(String condition) {
        this.condition = condition;
    }

    public String getSeparator() {
        return separator;
    }

    @XmlElement(name = "separator")
    public void setSeparator(String separator) {
        this.separator = separator;
    }

    public String getValue() {
        return value;
    }

    @XmlElement(name = "value")
    public void setValue(String value) {
        this.value = value;
    }

    public Integer getOrdinal() {
        return ordinal;
    }

    @XmlElement(name = "ordinal")
    public void setOrdinal(Integer ordinal) {
        this.ordinal = ordinal;
    }

    @Component(QueryConfigPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class QueryConfigPersistValidator extends BaseValidator<QueryConfigPersist> {

        public static final String ValidatorName = "QueryConfigPersistValidator";

        protected QueryConfigPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors) {
            super(conventionService, errors);
        }

        @Override
        protected Class<QueryConfigPersist> modelClass() {
            return QueryConfigPersist.class;
        }

        @Override
        protected List<Specification> specifications(QueryConfigPersist item) {
            return new ArrayList<>();
        }
    }

}
