package eu.eudat.model.persist.referencetypedefinition;

import eu.eudat.commons.enums.ReferenceTypeExternalApiHTTPMethodType;
import eu.eudat.commons.validation.ValidatorFactory;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;

public class ReferenceTypeSourceExternalApiConfigurationPersist extends ReferenceTypeSourceBaseConfigurationPersist {

    private String url;

    public static final String _url = "url";

    private ResultsConfigurationPersist results;

    public static final String _results = "results";

    private String paginationPath;

    public static final String _paginationPath = "paginationPath";

    private String contentType;

    public static final String _contentType = "contentType";

    private String firstPage;

    public static final String _firstPage = "firstPage";

    private ReferenceTypeExternalApiHTTPMethodType httpMethod;

    public static final String _httpMethod = "httpMethod";

    private String requestBody = "";

    private String filterType = "remote";

    private AuthenticationConfigurationPersist auth;

    public static final String _auth = "auth";

    private List<QueryConfigPersist> queries;

    public static final String _queries = "queries";

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public ResultsConfigurationPersist getResults() {
        return results;
    }

    public void setResults(ResultsConfigurationPersist results) {
        this.results = results;
    }

    public String getPaginationPath() {
        return paginationPath;
    }

    public void setPaginationPath(String paginationPath) {
        this.paginationPath = paginationPath;
    }

    public String getContentType() {
        return contentType;
    }

    public void setContentType(String contentType) {
        this.contentType = contentType;
    }

    public String getFirstPage() {
        return firstPage;
    }

    public void setFirstPage(String firstPage) {
        this.firstPage = firstPage;
    }

    public ReferenceTypeExternalApiHTTPMethodType getHttpMethod() {
        return httpMethod;
    }

    public void setHttpMethod(ReferenceTypeExternalApiHTTPMethodType httpMethod) {
        this.httpMethod = httpMethod;
    }

    public String getRequestBody() {
        return requestBody;
    }

    public void setRequestBody(String requestBody) {
        this.requestBody = requestBody;
    }

    public String getFilterType() {
        return filterType;
    }

    public void setFilterType(String filterType) {
        this.filterType = filterType;
    }

    public AuthenticationConfigurationPersist getAuth() {
        return auth;
    }

    public void setAuth(AuthenticationConfigurationPersist auth) {
        this.auth = auth;
    }

    public List<QueryConfigPersist> getQueries() {
        return queries;
    }

    public void setQueries(List<QueryConfigPersist> queries) {
        this.queries = queries;
    }

    @Component(ReferenceTypeSourceExternalApiConfigurationPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class ReferenceTypeSourceExternalApiConfigurationPersistValidator extends ReferenceTypeSourceBaseConfigurationPersistValidator<ReferenceTypeSourceExternalApiConfigurationPersist> {

        public static final String ValidatorName = "ReferenceTypeSourceExternalApiConfigurationPersistValidator";

        protected ReferenceTypeSourceExternalApiConfigurationPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource, ValidatorFactory validatorFactory) {
            super(conventionService, errors, messageSource, validatorFactory);
        }

        @Override
        protected Class<ReferenceTypeSourceExternalApiConfigurationPersist> modelClass() {
            return ReferenceTypeSourceExternalApiConfigurationPersist.class;
        }

        @Override
        protected List<Specification> specifications(ReferenceTypeSourceExternalApiConfigurationPersist item) {
            List<Specification> specifications = getBaseSpecifications(item);
            specifications.addAll(Arrays.asList(
                    this.spec()
                            .must(() -> !this.isEmpty(item.getUrl()))
                            .failOn(ReferenceTypeSourceExternalApiConfigurationPersist._url).failWith(messageSource.getMessage("Validation_Required", new Object[]{ReferenceTypeSourceExternalApiConfigurationPersist._url}, LocaleContextHolder.getLocale())),
                    this.spec()
                            .must(() -> !this.isEmpty(item.getPaginationPath()))
                            .failOn(ReferenceTypeSourceExternalApiConfigurationPersist._paginationPath).failWith(messageSource.getMessage("Validation_Required", new Object[]{ReferenceTypeSourceExternalApiConfigurationPersist._paginationPath}, LocaleContextHolder.getLocale())),
                    this.spec()
                            .must(() -> !this.isEmpty(item.getContentType()))
                            .failOn(ReferenceTypeSourceExternalApiConfigurationPersist._contentType).failWith(messageSource.getMessage("Validation_Required", new Object[]{ReferenceTypeSourceExternalApiConfigurationPersist._contentType}, LocaleContextHolder.getLocale())),
                    this.spec()
                            .must(() -> !this.isEmpty(item.getFirstPage()))
                            .failOn(ReferenceTypeSourceExternalApiConfigurationPersist._firstPage).failWith(messageSource.getMessage("Validation_Required", new Object[]{ReferenceTypeSourceExternalApiConfigurationPersist._firstPage}, LocaleContextHolder.getLocale())),
                    this.spec()
                            .must(() -> !this.isNull(item.getHttpMethod()))
                            .failOn(ReferenceTypeSourceExternalApiConfigurationPersist._httpMethod).failWith(messageSource.getMessage("Validation_Required", new Object[]{ReferenceTypeSourceExternalApiConfigurationPersist._httpMethod}, LocaleContextHolder.getLocale())),

                    this.spec()
                            .must(() -> !this.isNull(item.getResults()))
                            .failOn(ReferenceTypeSourceExternalApiConfigurationPersist._results).failWith(messageSource.getMessage("Validation_Required", new Object[]{ReferenceTypeSourceExternalApiConfigurationPersist._results}, LocaleContextHolder.getLocale())),
                    this.refSpec()
                            .iff(() -> !this.isNull(item.getResults()))
                            .on(ReferenceTypeSourceExternalApiConfigurationPersist._results)
                            .over(item.getResults())
                            .using(() -> this.validatorFactory.validator(ResultsConfigurationPersist.ResultsConfigurationPersistValidator.class)),
                    this.spec()
                            .must(() -> !this.isNull(item.getAuth()))
                            .failOn(ReferenceTypeSourceExternalApiConfigurationPersist._auth).failWith(messageSource.getMessage("Validation_Required", new Object[]{ReferenceTypeSourceExternalApiConfigurationPersist._auth}, LocaleContextHolder.getLocale())),
                    this.refSpec()
                            .iff(() -> !this.isNull(item.getAuth()))
                            .on(ReferenceTypeSourceExternalApiConfigurationPersist._auth)
                            .over(item.getAuth())
                            .using(() -> this.validatorFactory.validator(AuthenticationConfigurationPersist.AuthenticationConfigurationPersistValidator.class)),
                    this.spec()
                            .must(() -> !this.isNull(item.getQueries()))
                            .failOn(ReferenceTypeSourceExternalApiConfigurationPersist._queries).failWith(messageSource.getMessage("Validation_Required", new Object[]{ReferenceTypeSourceExternalApiConfigurationPersist._queries}, LocaleContextHolder.getLocale())),
                    this.navSpec()
                            .iff(() -> !this.isNull(item.getQueries()))
                            .on(ReferenceTypeSourceExternalApiConfigurationPersist._queries)
                            .over(item.getQueries())
                            .using(() -> this.validatorFactory.validator(QueryConfigPersist.QueryConfigPersistValidator.class))
            ));
            return specifications;
        }
    }

}
