package eu.eudat.model.persist.referencetypedefinition;

import eu.eudat.commons.validation.ValidatorFactory;
import eu.eudat.commons.validation.specification.Specification;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.MessageSource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.List;

public class ReferenceTypeSourceStaticOptionConfigurationPersist extends ReferenceTypeSourceBaseConfigurationPersist {

    List<ReferenceTypeStaticOptionPersist> options;

    public static final String _options = "options";

    public List<ReferenceTypeStaticOptionPersist> getOptions() {
        return options;
    }

    public void setOptions(List<ReferenceTypeStaticOptionPersist> options) {
        this.options = options;
    }

    @Component(ReferenceTypeSourceStaticOptionConfigurationPersistValidator.ValidatorName)
    @Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
    public static class ReferenceTypeSourceStaticOptionConfigurationPersistValidator extends ReferenceTypeSourceBaseConfigurationPersistValidator<ReferenceTypeSourceStaticOptionConfigurationPersist> {

        public static final String ValidatorName = "ReferenceTypeSourceStaticOptionConfigurationPersistValidator";

        protected ReferenceTypeSourceStaticOptionConfigurationPersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, MessageSource messageSource, ValidatorFactory validatorFactory) {
            super(conventionService, errors, messageSource, validatorFactory);
        }

        @Override
        protected Class<ReferenceTypeSourceStaticOptionConfigurationPersist> modelClass() {
            return ReferenceTypeSourceStaticOptionConfigurationPersist.class;
        }

        @Override
        protected List<Specification> specifications(ReferenceTypeSourceStaticOptionConfigurationPersist item) {
            List<Specification> specifications = getBaseSpecifications(item);
            specifications.add(
                    this.refSpec()
                            .iff(() -> !this.isNull(item.getOptions()))
                            .on(ReferenceTypeSourceStaticOptionConfigurationPersist._options)
                            .over(item.getOptions())
                            .using(() -> this.validatorFactory.validator(ReferenceTypeStaticOptionPersist.ReferenceTypeStaticOptionPersistValidator.class))
            );
            return specifications;
        }
    }

}
