package eu.eudat.service.fielddatahelper;

import eu.eudat.authorization.AuthorizationFlags;
import eu.eudat.commons.enums.FieldType;
import eu.eudat.commons.types.descriptiontemplate.fielddata.AutoCompleteDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.BaseFieldDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.BooleanDecisionDataEntity;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.BooleanDecisionDataImportExport;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.WordListDataImportExport;
import eu.eudat.model.builder.descriptiontemplatedefinition.fielddata.BooleanDecisionDataBuilder;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.BaseFieldData;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.BooleanDecisionData;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.*;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.fieldset.FieldSet;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;
import org.w3c.dom.Element;

import java.util.ArrayList;
import java.util.EnumSet;
import java.util.List;

@Component
public class BooleanDecisionFieldDataHelperService extends BaseFieldDataHelperService<BooleanDecisionData, BooleanDecisionDataPersist, BooleanDecisionDataEntity, BooleanDecisionDataImportExport> {
	private final BuilderFactory builderFactory;

	public BooleanDecisionFieldDataHelperService(BuilderFactory builderFactory) {
		this.builderFactory = builderFactory;
	}

	@Override
	public FieldType getFormType() {
		return FieldType.BOOLEAN_DECISION;
	}

	@Override
	public BooleanDecisionDataEntity newDataInstanceInternal() {
		return new BooleanDecisionDataEntity();
	}

	@Override
	public BooleanDecisionData newModelInstanceInternal() {
		return new BooleanDecisionData();
	}

	@Override
	public BooleanDecisionDataPersist newPersistModelInstanceInternal() {
		return new BooleanDecisionDataPersist();
	}

	@Override
	protected BooleanDecisionDataImportExport newImportExportInstanceInternal() {
		return new BooleanDecisionDataImportExport();
	}

	@Override
	public Class<?> getDataClass() {
		return BooleanDecisionDataEntity.class;
	}
	@Override
	public Class<?> getModelClass() {
		return BooleanDecisionData.class;
	}
	@Override
	public Class<?> getPersistModelClass() {
		return BooleanDecisionDataPersist.class;
	}

	@Override
	public Class<?> getImportExportClass() {
		return BooleanDecisionDataImportExport.class;
	}

	@Override
	public List<BooleanDecisionData> buildInternal(FieldSet fieldSet, List<BooleanDecisionDataEntity> data, EnumSet<AuthorizationFlags> authorizationFlags){
		return this.builderFactory.builder(BooleanDecisionDataBuilder.class).authorize(authorizationFlags).build(fieldSet, data);
	}

	@Override
	protected BooleanDecisionDataEntity applyPersistInternal(BooleanDecisionDataPersist persist, BooleanDecisionDataEntity data) {
		return data;
	}

	@Override
	protected BooleanDecisionDataPersist importExportMapDataToPersistInternal(BooleanDecisionDataImportExport data, BooleanDecisionDataPersist persist) {
		return persist;
	}

	@Override
	protected BooleanDecisionDataImportExport dataToImportExportXmlInternal(BooleanDecisionDataEntity data, BooleanDecisionDataImportExport xml) {
		return xml;
	}

	@Override
	protected boolean isMultiValueInternal(BooleanDecisionDataEntity data) {
		return false;
	}

}
