package eu.eudat.service.fielddatahelper;

import eu.eudat.authorization.AuthorizationFlags;
import eu.eudat.commons.enums.FieldType;
import eu.eudat.commons.types.descriptiontemplate.fielddata.BaseFieldDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.DataRepositoryDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.DatasetAutoCompleteDataEntity;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.DatasetAutoCompleteDataImportExport;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.WordListDataImportExport;
import eu.eudat.model.builder.descriptiontemplatedefinition.fielddata.DatasetAutoCompleteDataBuilder;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.BaseFieldData;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.DatasetAutoCompleteData;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.BaseFieldDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.DataRepositoryDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.DatasetAutoCompleteDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.WordListDataPersist;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.fieldset.FieldSet;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.EnumSet;
import java.util.List;

@Component
public class DatasetAutoCompleteFieldDataHelperService extends BaseFieldDataHelperService<DatasetAutoCompleteData, DatasetAutoCompleteDataPersist, DatasetAutoCompleteDataEntity, DatasetAutoCompleteDataImportExport> {
	
	private final BuilderFactory builderFactory;

	public DatasetAutoCompleteFieldDataHelperService(BuilderFactory builderFactory) {
		this.builderFactory = builderFactory;
	}


	@Override
	public FieldType getFormType() {
		return FieldType.INTERNAL_DMP_ENTRIES_DATASETS;
	}

	@Override
	public DatasetAutoCompleteDataEntity newDataInstanceInternal() {
		return new DatasetAutoCompleteDataEntity();
	}

	@Override
	public DatasetAutoCompleteData newModelInstanceInternal() {
		return new DatasetAutoCompleteData();
	}

	@Override
	public DatasetAutoCompleteDataPersist newPersistModelInstanceInternal() {
		return new DatasetAutoCompleteDataPersist();
	}

	@Override
	protected DatasetAutoCompleteDataImportExport newImportExportInstanceInternal() {
		return new DatasetAutoCompleteDataImportExport();
	}

	@Override
	public Class<?> getDataClass() {
		return DatasetAutoCompleteDataEntity.class;
	}
	@Override
	public Class<?> getModelClass() {
		return DatasetAutoCompleteData.class;
	}

	@Override
	public Class<?> getPersistModelClass() {
		return DatasetAutoCompleteDataPersist.class;
	}

	@Override
	public Class<?> getImportExportClass() {
		return DatasetAutoCompleteDataImportExport.class;
	}

	@Override
	public List<DatasetAutoCompleteData> buildInternal(FieldSet fieldSet, List<DatasetAutoCompleteDataEntity> data, EnumSet<AuthorizationFlags> authorizationFlags){
		return this.builderFactory.builder(DatasetAutoCompleteDataBuilder.class).authorize(authorizationFlags).build(fieldSet, data);
	}

	@Override
	protected DatasetAutoCompleteDataEntity applyPersistInternal(DatasetAutoCompleteDataPersist persist, DatasetAutoCompleteDataEntity data) {
		data.setMultiAutoComplete(persist.getMultiAutoComplete());
		return data;
	}

	@Override
	protected DatasetAutoCompleteDataPersist importExportMapDataToPersistInternal(DatasetAutoCompleteDataImportExport data, DatasetAutoCompleteDataPersist persist) {
		persist.setMultiAutoComplete(data.getMultiAutoComplete());
		return persist;
	}

	@Override
	protected DatasetAutoCompleteDataImportExport dataToImportExportXmlInternal(DatasetAutoCompleteDataEntity data, DatasetAutoCompleteDataImportExport xml) {
		xml.setMultiAutoComplete(data.getMultiAutoComplete());
		return xml;
	}

	@Override
	protected boolean isMultiValueInternal(DatasetAutoCompleteDataEntity data) {
		return data.getMultiAutoComplete();
	}
}
