package eu.eudat.service.fielddatahelper;

import eu.eudat.authorization.AuthorizationFlags;
import eu.eudat.commons.enums.FieldType;
import eu.eudat.commons.types.descriptiontemplate.fielddata.BaseFieldDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.BooleanDecisionDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.DatasetIdentifierDataEntity;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.DatasetIdentifierDataImportExport;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.WordListDataImportExport;
import eu.eudat.model.builder.descriptiontemplatedefinition.fielddata.DatasetIdentifierDataBuilder;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.BaseFieldData;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.DatasetIdentifierData;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.BaseFieldDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.BooleanDecisionDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.DatasetIdentifierDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.WordListDataPersist;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.fieldset.FieldSet;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.EnumSet;
import java.util.List;

@Component
public class DatasetIdentifierFieldDataHelperService extends BaseFieldDataHelperService<DatasetIdentifierData, DatasetIdentifierDataPersist, DatasetIdentifierDataEntity, DatasetIdentifierDataImportExport> {
	
	private final BuilderFactory builderFactory;

	public DatasetIdentifierFieldDataHelperService(BuilderFactory builderFactory) {
		this.builderFactory = builderFactory;
	}

	@Override
	public FieldType getFormType() {
		return FieldType.DATASET_IDENTIFIER;
	}

	@Override
	public DatasetIdentifierDataEntity newDataInstanceInternal() {
		return new DatasetIdentifierDataEntity();
	}

	@Override
	public DatasetIdentifierData newModelInstanceInternal() {
		return new DatasetIdentifierData();
	}

	@Override
	public DatasetIdentifierDataPersist newPersistModelInstanceInternal() {
		return new DatasetIdentifierDataPersist();
	}

	@Override
	protected DatasetIdentifierDataImportExport newImportExportInstanceInternal() {
		return new DatasetIdentifierDataImportExport();
	}

	@Override
	public Class<?> getDataClass() {
		return DatasetIdentifierDataEntity.class;
	}
	@Override
	public Class<?> getModelClass() {
		return DatasetIdentifierData.class;
	}
	@Override
	public Class<?> getPersistModelClass() {
		return DatasetIdentifierDataPersist.class;
	}

	@Override
	public Class<?> getImportExportClass() {
		return DatasetIdentifierDataImportExport.class;
	}

	@Override
	public List<DatasetIdentifierData> buildInternal(FieldSet fieldSet, List<DatasetIdentifierDataEntity> data, EnumSet<AuthorizationFlags> authorizationFlags){
		return this.builderFactory.builder(DatasetIdentifierDataBuilder.class).authorize(authorizationFlags).build(fieldSet, data);
	}

	@Override
	protected DatasetIdentifierDataEntity applyPersistInternal(DatasetIdentifierDataPersist persist, DatasetIdentifierDataEntity data) {
		return data;
	}

	@Override
	protected DatasetIdentifierDataPersist importExportMapDataToPersistInternal(DatasetIdentifierDataImportExport data, DatasetIdentifierDataPersist persist) {
		return persist;
	}

	@Override
	protected DatasetIdentifierDataImportExport dataToImportExportXmlInternal(DatasetIdentifierDataEntity data, DatasetIdentifierDataImportExport xml) {
		return xml;
	}

	@Override
	protected boolean isMultiValueInternal(DatasetIdentifierDataEntity data) {
		return false;
	}
}
