package eu.eudat.service.fielddatahelper;

import eu.eudat.authorization.AuthorizationFlags;
import eu.eudat.commons.enums.FieldType;
import eu.eudat.commons.types.descriptiontemplate.fielddata.BaseFieldDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.BooleanDecisionDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.DatePickerDataEntity;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.DatePickerDataImportExport;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.WordListDataImportExport;
import eu.eudat.model.builder.descriptiontemplatedefinition.fielddata.DatePickerDataBuilder;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.BaseFieldData;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.DatePickerData;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.BaseFieldDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.BooleanDecisionDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.DatePickerDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.WordListDataPersist;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.fieldset.FieldSet;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.EnumSet;
import java.util.List;

@Component
public class DatePickerFieldDataHelperService extends BaseFieldDataHelperService<DatePickerData, DatePickerDataPersist, DatePickerDataEntity, DatePickerDataImportExport> {
	
	private final BuilderFactory builderFactory;

	public DatePickerFieldDataHelperService(BuilderFactory builderFactory) {
		this.builderFactory = builderFactory;
	}


	@Override
	public FieldType getFormType() {
		return FieldType.DATE_PICKER;
	}

	@Override
	public DatePickerDataEntity newDataInstanceInternal() {
		return new DatePickerDataEntity();
	}

	@Override
	public DatePickerData newModelInstanceInternal() {
		return new DatePickerData();
	}
	@Override
	public DatePickerDataPersist newPersistModelInstanceInternal() {
		return new DatePickerDataPersist();
	}

	@Override
	protected DatePickerDataImportExport newImportExportInstanceInternal() {
		return new DatePickerDataImportExport();
	}

	@Override
	public Class<?> getDataClass() {
		return DatePickerDataEntity.class;
	}
	@Override
	public Class<?> getModelClass() {
		return DatePickerData.class;
	}
	@Override
	public Class<?> getPersistModelClass() {
		return DatePickerDataPersist.class;
	}

	@Override
	public Class<?> getImportExportClass() {
		return DatePickerDataImportExport.class;
	}

	@Override
	public List<DatePickerData> buildInternal(FieldSet fieldSet, List<DatePickerDataEntity> data, EnumSet<AuthorizationFlags> authorizationFlags){
		return this.builderFactory.builder(DatePickerDataBuilder.class).authorize(authorizationFlags).build(fieldSet, data);
	}

	@Override
	protected DatePickerDataEntity applyPersistInternal(DatePickerDataPersist persist, DatePickerDataEntity data) {
		return data;
	}

	@Override
	protected DatePickerDataPersist importExportMapDataToPersistInternal(DatePickerDataImportExport data, DatePickerDataPersist persist) {
		return persist;
	}

	@Override
	protected DatePickerDataImportExport dataToImportExportXmlInternal(DatePickerDataEntity data, DatePickerDataImportExport xml) {
		return xml;
	}

	@Override
	protected boolean isMultiValueInternal(DatePickerDataEntity data) {
		return false;
	}
}
