package eu.eudat.service.fielddatahelper;

import eu.eudat.authorization.AuthorizationFlags;
import eu.eudat.commons.enums.FieldType;
import eu.eudat.commons.types.descriptiontemplate.fielddata.BaseFieldDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.DataRepositoryDataEntity;
import eu.eudat.commons.types.descriptiontemplate.fielddata.ResearcherAutoCompleteDataEntity;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.ResearcherAutoCompleteDataImportExport;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.WordListDataImportExport;
import eu.eudat.model.builder.descriptiontemplatedefinition.fielddata.ResearcherAutoCompleteDataBuilder;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.BaseFieldData;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.ResearcherAutoCompleteData;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.BaseFieldDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.DataRepositoryDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.ResearcherAutoCompleteDataPersist;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.WordListDataPersist;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.fieldset.FieldSet;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.util.EnumSet;
import java.util.List;

@Component
public class ResearcherAutoCompleteFieldDataHelperService extends BaseFieldDataHelperService<ResearcherAutoCompleteData, ResearcherAutoCompleteDataPersist, ResearcherAutoCompleteDataEntity, ResearcherAutoCompleteDataImportExport> {
	
	private final BuilderFactory builderFactory;

	public ResearcherAutoCompleteFieldDataHelperService(BuilderFactory builderFactory) {
		this.builderFactory = builderFactory;
	}


	@Override
	public FieldType getFormType() {
		return FieldType.INTERNAL_DMP_ENTRIES_RESEARCHERS;
	}

	@Override
	public ResearcherAutoCompleteDataEntity newDataInstanceInternal() {
		return new ResearcherAutoCompleteDataEntity();
	}

	@Override
	public ResearcherAutoCompleteData newModelInstanceInternal() {
		return new ResearcherAutoCompleteData();
	}

	@Override
	public ResearcherAutoCompleteDataPersist newPersistModelInstanceInternal() {
		return new ResearcherAutoCompleteDataPersist();
	}

	@Override
	protected ResearcherAutoCompleteDataImportExport newImportExportInstanceInternal() {
		return new ResearcherAutoCompleteDataImportExport();
	}

	@Override
	public Class<?> getDataClass() {
		return ResearcherAutoCompleteDataEntity.class;
	}
	@Override
	public Class<?> getModelClass() {
		return ResearcherAutoCompleteData.class;
	}
	@Override
	public Class<?> getPersistModelClass() {
		return ResearcherAutoCompleteDataPersist.class;
	}

	@Override
	public Class<?> getImportExportClass() {
		return ResearcherAutoCompleteDataImportExport.class;
	}

	@Override
	public List<ResearcherAutoCompleteData> buildInternal(FieldSet fieldSet, List<ResearcherAutoCompleteDataEntity> data, EnumSet<AuthorizationFlags> authorizationFlags){
		return this.builderFactory.builder(ResearcherAutoCompleteDataBuilder.class).authorize(authorizationFlags).build(fieldSet, data);
	}

	@Override
	protected ResearcherAutoCompleteDataEntity applyPersistInternal(ResearcherAutoCompleteDataPersist persist, ResearcherAutoCompleteDataEntity data) {
		data.setMultiAutoComplete(persist.getMultiAutoComplete());
		return data;
	}

	@Override
	protected ResearcherAutoCompleteDataPersist importExportMapDataToPersistInternal(ResearcherAutoCompleteDataImportExport data, ResearcherAutoCompleteDataPersist persist){
		persist.setMultiAutoComplete(data.getMultiAutoComplete());
		return persist;
	}

	@Override
	protected ResearcherAutoCompleteDataImportExport dataToImportExportXmlInternal(ResearcherAutoCompleteDataEntity data, ResearcherAutoCompleteDataImportExport xml) {
		xml.setMultiAutoComplete(data.getMultiAutoComplete());
		return xml;
	}

	@Override
	protected boolean isMultiValueInternal(ResearcherAutoCompleteDataEntity data) {
		return data.getMultiAutoComplete();
	}
}
