package eu.eudat.data.dao;


import eu.eudat.queryable.QueryableList;
import eu.eudat.data.old.queryableentity.DataEntity;

import javax.management.InvalidApplicationException;
import java.util.concurrent.CompletableFuture;

public interface DatabaseAccessLayer<T extends DataEntity, I> {
    T createOrUpdate(T item);

    CompletableFuture<T> createOrUpdateAsync(T item);
    
    T find(I id) throws InvalidApplicationException;

    T find(I id, String hint) throws InvalidApplicationException;

    void delete(T item);

    QueryableList<T> asQueryable();
}
