package eu.eudat.data.dao.entities;

import eu.eudat.data.dao.DatabaseAccessLayer;
import eu.eudat.data.dao.criteria.DatasetCriteria;
import eu.eudat.data.DescriptionEntity;
import eu.eudat.data.UserEntity;
import eu.eudat.queryable.QueryableList;

import javax.management.InvalidApplicationException;
import java.util.List;
import java.util.UUID;

public interface DatasetDao extends DatabaseAccessLayer<DescriptionEntity, UUID> {

    QueryableList<DescriptionEntity> getWithCriteria(DatasetCriteria criteria);

    QueryableList<DescriptionEntity> filterFromElastic(DatasetCriteria criteria, List<UUID> ids);

    QueryableList<DescriptionEntity> getAuthenticated(QueryableList<DescriptionEntity> query, UserEntity principal, List<Integer> roles);

    DescriptionEntity isPublicDataset(UUID id) throws InvalidApplicationException;

}