package eu.eudat.data.dao.entities;

import eu.eudat.data.DescriptionTemplateTypeEntity;
import eu.eudat.data.dao.DatabaseAccessLayer;
import eu.eudat.data.dao.criteria.DatasetProfileCriteria;
import eu.eudat.data.DescriptionTemplateEntity;
import eu.eudat.queryable.QueryableList;

import javax.management.InvalidApplicationException;
import java.util.List;
import java.util.UUID;

public interface DatasetProfileDao extends DatabaseAccessLayer<DescriptionTemplateEntity, UUID> {

    QueryableList<DescriptionTemplateEntity> getWithCriteria(DatasetProfileCriteria criteria);

    QueryableList<DescriptionTemplateEntity> getAll();

    QueryableList<DescriptionTemplateEntity> getAuthenticated(QueryableList<DescriptionTemplateEntity> query, UUID principal, List<Integer> roles);

    List<DescriptionTemplateEntity> getAllIds() throws InvalidApplicationException;

    Long countWithType(DescriptionTemplateTypeEntity type) throws InvalidApplicationException;

}