package gr.cite.notification.data;

import gr.cite.notification.common.enums.*;
import gr.cite.notification.data.conventers.*;
import gr.cite.notification.data.tenant.TenantScopedBaseEntity;

import javax.persistence.*;
import java.time.Instant;
import java.util.UUID;

@Entity
@Table(name = "\"ntf_NotificationTemplate\"")
public class NotificationTemplateEntity extends TenantScopedBaseEntity {

    @Id
    @Column(name = "\"id\"", columnDefinition = "uuid", updatable = false, nullable = false)
    private UUID id;
    public final static String _id = "id";

    @Column(name = "\"channel\"", nullable = false)
    @Convert(converter = NotificationTemplateChannelConverter.class)
    private NotificationTemplateChannel channel;
    public final static String _channel = "channel";

    @Column(name = "\"notification_type\"", columnDefinition = "uuid", nullable = false)
    private UUID notificationType;
    public final static String _notificationType = "notificationType";

    @Column(name = "\"kind\"", nullable = false)
    @Convert(converter = NotificationTemplateKindConverter.class)
    private NotificationTemplateKind kind;
    public final static String _kind = "kind";

    @Column(name = "\"language\"", columnDefinition = "uuid", nullable = false)
    private UUID languageId;
    public final static String _languageId = "languageId";

    @Column(name = "\"value\"", nullable = false)
    private String value;
    public final static String _value = "value";

    @Column(name = "\"is_active\"", nullable = false)
    @Convert(converter = IsActiveConverter.class)
    private IsActive isActive;
    public final static String _isActive = "isActive";

    @Column(name = "\"created_at\"", nullable = false)
    private Instant createdAt;
    public final static String _createdAt = "createdAt";

    @Column(name = "\"updated_at\"", nullable = false)
    private Instant updatedAt;
    public final static String _updatedAt = "updatedAt";

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public NotificationTemplateChannel getChannel() {
        return channel;
    }

    public void setChannel(NotificationTemplateChannel channel) {
        this.channel = channel;
    }

    public UUID getNotificationType() {
        return notificationType;
    }

    public void setNotificationType(UUID notificationType) {
        this.notificationType = notificationType;
    }

    public NotificationTemplateKind getKind() {
        return kind;
    }

    public void setKind(NotificationTemplateKind kind) {
        this.kind = kind;
    }

    public UUID getLanguageId() {
        return languageId;
    }

    public void setLanguageId(UUID languageId) {
        this.languageId = languageId;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public IsActive getIsActive() {
        return isActive;
    }

    public void setIsActive(IsActive isActive) {
        this.isActive = isActive;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }
}
