package gr.cite.notification.model.persist;

import gr.cite.notification.common.enums.NotificationTemplateChannel;
import gr.cite.notification.common.enums.NotificationTemplateKind;
import gr.cite.notification.common.validation.ValidEnum;
import gr.cite.notification.common.validation.ValidId;
import gr.cite.notification.model.persist.notificationtemplate.NotificationTemplateValuePersist;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.UUID;

public class NotificationTemplatePersist {

    @ValidId(message = "{validation.invalidid}")
    private UUID id;

    @ValidEnum
    private NotificationTemplateChannel channel;

    @NotNull
    @Valid
    private UUID notificationType;

    @ValidEnum
    private NotificationTemplateKind kind;

    @NotNull(message = "{validation.empty}")
    @ValidId(message = "{validation.invalidid}")
    private UUID languageId;

    @NotNull(message = "{validation.empty}")
    @Valid
    private NotificationTemplateValuePersist value;

    private String hash;

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public NotificationTemplateChannel getChannel() {
        return channel;
    }

    public void setChannel(NotificationTemplateChannel channel) {
        this.channel = channel;
    }

    public UUID getNotificationType() {
        return notificationType;
    }

    public void setNotificationType(UUID notificationType) {
        this.notificationType = notificationType;
    }

    public NotificationTemplateKind getKind() {
        return kind;
    }

    public void setKind(NotificationTemplateKind kind) {
        this.kind = kind;
    }

    public UUID getLanguageId() {
        return languageId;
    }

    public void setLanguageId(UUID languageId) {
        this.languageId = languageId;
    }

    public NotificationTemplateValuePersist getValue() {
        return value;
    }

    public void setValue(NotificationTemplateValuePersist value) {
        this.value = value;
    }

    public String getHash() {
        return hash;
    }

    public void setHash(String hash) {
        this.hash = hash;
    }
}
