package gr.cite.notification.model.persist.notificationtemplate;

import gr.cite.notification.common.enums.EmailOverrideMode;
import gr.cite.notification.common.validation.ValidEnum;

import javax.validation.Valid;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;

public class NotificationTemplateValuePersist {

    @NotNull
    @NotEmpty
    private String subjectText;

    @NotNull
    @NotEmpty
    private String subjectKey;

    @Valid
    private FieldOptionsPersist subjectFieldOptions;

    @NotNull
    @NotEmpty
    private String bodyText;

    @NotNull
    @NotEmpty
    private String bodyKey;
    private String priorityKey;
    @NotNull
    private Boolean allowAttachments = false;
    private List<String> cc;

    @ValidEnum
    private EmailOverrideMode ccMode;
    private List<String> bcc;

    @ValidEnum
    private EmailOverrideMode bccMode;
    private List<String> extraDataKeys;

    @Valid
    private FieldOptionsPersist bodyFieldOptions;

    public String getSubjectText() {
        return subjectText;
    }

    public void setSubjectText(String subjectText) {
        this.subjectText = subjectText;
    }

    public String getSubjectKey() {
        return subjectKey;
    }

    public void setSubjectKey(String subjectKey) {
        this.subjectKey = subjectKey;
    }

    public FieldOptionsPersist getSubjectFieldOptions() {
        return subjectFieldOptions;
    }

    public void setSubjectFieldOptions(FieldOptionsPersist subjectFieldOptions) {
        this.subjectFieldOptions = subjectFieldOptions;
    }

    public String getBodyText() {
        return bodyText;
    }

    public void setBodyText(String bodyText) {
        this.bodyText = bodyText;
    }

    public String getBodyKey() {
        return bodyKey;
    }

    public void setBodyKey(String bodyKey) {
        this.bodyKey = bodyKey;
    }

    public String getPriorityKey() {
        return priorityKey;
    }

    public void setPriorityKey(String priorityKey) {
        this.priorityKey = priorityKey;
    }

    public Boolean getAllowAttachments() {
        return allowAttachments;
    }

    public void setAllowAttachments(Boolean allowAttachments) {
        this.allowAttachments = allowAttachments;
    }

    public List<String> getCc() {
        return cc;
    }

    public void setCc(List<String> cc) {
        this.cc = cc;
    }

    public EmailOverrideMode getCcMode() {
        return ccMode;
    }

    public void setCcMode(EmailOverrideMode ccMode) {
        this.ccMode = ccMode;
    }

    public List<String> getBcc() {
        return bcc;
    }

    public void setBcc(List<String> bcc) {
        this.bcc = bcc;
    }

    public EmailOverrideMode getBccMode() {
        return bccMode;
    }

    public void setBccMode(EmailOverrideMode bccMode) {
        this.bccMode = bccMode;
    }

    public List<String> getExtraDataKeys() {
        return extraDataKeys;
    }

    public void setExtraDataKeys(List<String> extraDataKeys) {
        this.extraDataKeys = extraDataKeys;
    }

    public FieldOptionsPersist getBodyFieldOptions() {
        return bodyFieldOptions;
    }

    public void setBodyFieldOptions(FieldOptionsPersist bodyFieldOptions) {
        this.bodyFieldOptions = bodyFieldOptions;
    }
}
