package eu.eudat.logic.builders;

import eu.eudat.logic.builders.entity.*;
import eu.eudat.logic.builders.model.models.*;
import org.springframework.stereotype.Service;


@Service
public class BuilderFactoryImpl implements BuilderFactory {

    public <T extends Builder> T getBuilder(Class<T> tClass) {
        if (tClass.equals(DatasetProfileBuilder.class)) return (T) new DatasetProfileBuilder();
        if (tClass.equals(DataTableDataBuilder.class)) return (T) new DataTableDataBuilder<>();
        if (tClass.equals(UserInfoBuilder.class)) return (T) new UserInfoBuilder();
        if (tClass.equals(UserRoleBuilder.class)) return (T) new UserRoleBuilder();
        if (tClass.equals(RecentActivityDataBuilder.class)) return (T) new RecentActivityDataBuilder();

        return null;
    }
}
