package eu.eudat.logic.builders.entity;

import eu.eudat.logic.builders.Builder;
import eu.eudat.data.UserEntity;
import eu.eudat.data.UserRoleEntity;

import java.util.UUID;

/**
 * Created by ikalyvas on 2/15/2018.
 */
public class UserRoleBuilder extends Builder<UserRoleEntity> {

    private UUID id;

    private String role;

    private UUID userId;

    public UserRoleBuilder id(UUID id) {
        this.id = id;
        return this;
    }

    public UserRoleBuilder role(String role) {
        this.role = role;
        return this;
    }

    public UserRoleBuilder userInfo(UserEntity userInfo) {
        this.userId = userInfo.getId();
        return this;
    }

    @Override
    public UserRoleEntity build() {
        UserRoleEntity userRole = new UserRoleEntity();
        userRole.setUserId(userId);
        userRole.setRole(role);
        userRole.setId(id);
        return userRole;
    }
}
