package eu.eudat.logic.services.operations;

import eu.eudat.data.dao.entities.*;
import jakarta.persistence.EntityManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("databaseRepository")
public class DatabaseRepositoryImpl implements DatabaseRepository {

    private DatasetDao datasetDao;

    private DatasetProfileDao datasetProfileDao;

    private DMPDao dmpDao;


    private InvitationDao invitationDao;


    private EmailConfirmationDao loginConfirmationEmailDao;


    private FileUploadDao fileUploadDao;

    private EntityManager entityManager;


    @Autowired
    private void setDatasetDao(DatasetDao datasetDao) {
        this.datasetDao = datasetDao;
    }

    @Autowired
    private void setDatasetProfileDao(DatasetProfileDao datasetProfileDao) {
        this.datasetProfileDao = datasetProfileDao;
    }

    @Autowired
    private void setDmpDao(DMPDao dmpDao) {
        this.dmpDao = dmpDao;
    }

    @Autowired

    @Override
    public DatasetDao getDatasetDao() {
        return datasetDao;
    }

    @Override
    public DatasetProfileDao getDatasetProfileDao() {
        return datasetProfileDao;
    }

    @Override
    public DMPDao getDmpDao() {
        return dmpDao;
    }


    @Override
    public InvitationDao getInvitationDao() {
        return invitationDao;
    }

    @Autowired
    public void setInvitationDao(InvitationDao invitationDao) {
        this.invitationDao = invitationDao;
    }

    @Autowired
    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    @Override
    public EmailConfirmationDao getLoginConfirmationEmailDao() {
        return loginConfirmationEmailDao;
    }

    @Autowired
    public void setLoginConfirmationEmailDao(EmailConfirmationDao loginConfirmationEmailDao) {
        this.loginConfirmationEmailDao = loginConfirmationEmailDao;
    }


    @Override
    public FileUploadDao getFileUploadDao() {
        return fileUploadDao;
    }

    @Autowired
    public void setFileUploadDao(FileUploadDao fileUploadDao) {
        this.fileUploadDao = fileUploadDao;
    }

    public <T> void detachEntity(T entity) {
        this.entityManager.detach(entity);
    }
}
