package eu.eudat.logic.utilities.documents.xml.datasetProfileXml;
import eu.eudat.commons.types.descriptiontemplate.importexport.DescriptionTemplateImportExport;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import jakarta.xml.bind.JAXBContext;
import jakarta.xml.bind.JAXBException;
import jakarta.xml.bind.Unmarshaller;
import java.io.*;

public class ImportXmlBuilderDatasetProfile {
    private static final Logger logger = LoggerFactory.getLogger(ImportXmlBuilderDatasetProfile.class);

    public DescriptionTemplateImportExport build(File xmlFile) throws IOException {
        DescriptionTemplateImportExport descriptionTemplateImportXml = new DescriptionTemplateImportExport();
        JAXBContext jaxbContext = null;
        try {
            jaxbContext = JAXBContext.newInstance(DescriptionTemplateImportExport.class);
            Unmarshaller unmarshaller = jaxbContext.createUnmarshaller();
            descriptionTemplateImportXml = (DescriptionTemplateImportExport) unmarshaller.unmarshal(xmlFile);
        } catch (JAXBException e) {
            logger.error(e.getMessage(), e);
        }

        return descriptionTemplateImportXml;
    }


}
