package eu.eudat.models.data.listingmodels;

import eu.eudat.data.DmpEntity;
import eu.eudat.model.DmpUser;
import eu.eudat.model.EntityDoi;
import eu.eudat.models.DataModel;
import eu.eudat.models.data.dataset.DatasetOverviewModel;
import eu.eudat.models.data.dmp.AssociatedProfile;

import java.util.Date;
import java.util.List;
import java.util.UUID;

public class DataManagementPlanOverviewModel implements DataModel<DmpEntity, DataManagementPlanOverviewModel> {
    private String id;
    private String label;
    private String profile;
    private Date creationTime;
    private Date modifiedTime;
    private Date finalizedAt;
    private int version;
    private int status;
    private UUID groupId;
    private List<DatasetOverviewModel> datasets;
    private List<AssociatedProfile> associatedProfiles;
    private List<DmpUser> users;
    private String description;
    private boolean isPublic;
    private Date publishedAt;
    private List<EntityDoi> dois;


    public String getId() {
        return id;
    }
    public void setId(String id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }
    public void setLabel(String label) {
        this.label = label;
    }

    public String getProfile() {
        return profile;
    }
    public void setProfile(String profile) {
        this.profile = profile;
    }

    public Date getCreationTime() {
        return creationTime;
    }
    public void setCreationTime(Date creationTime) {
        this.creationTime = creationTime;
    }

    public Date getModifiedTime() {
        return modifiedTime;
    }
    public void setModifiedTime(Date modifiedTime) {
        this.modifiedTime = modifiedTime;
    }

    public Date getFinalizedAt() {
        return finalizedAt;
    }
    public void setFinalizedAt(Date finalizedAt) {
        this.finalizedAt = finalizedAt;
    }

    public int getVersion() {
        return version;
    }
    public void setVersion(int version) {
        this.version = version;
    }

    public UUID getGroupId() {
        return groupId;
    }
    public void setGroupId(UUID groupId) {
        this.groupId = groupId;
    }

    public List<DatasetOverviewModel> getDatasets() {
        return datasets;
    }
    public void setDatasets(List<DatasetOverviewModel> datasets) {
        this.datasets = datasets;
    }

    public int getStatus() {
        return status;
    }
    public void setStatus(int status) {
        this.status = status;
    }

    public List<AssociatedProfile> getAssociatedProfiles() {
        return associatedProfiles;
    }
    public void setAssociatedProfiles(List<AssociatedProfile> associatedProfiles) {
        this.associatedProfiles = associatedProfiles;
    }

    public List<DmpUser> getUsers() {
        return users;
    }
    public void setUsers(List<DmpUser> users) {
        this.users = users;
    }

    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }


    public boolean getIsPublic() {
        return isPublic;
    }
    public void setIsPublic(boolean aPublic) {
        isPublic = aPublic;
    }

    public Date getPublishedAt() {
        return publishedAt;
    }
    public void setPublishedAt(Date publishedAt) {
        this.publishedAt = publishedAt;
    }

    public List<EntityDoi> getDois() {
        return dois;
    }
    public void setDois(List<EntityDoi> dois) {
        this.dois = dois;
    }

    @Override
    public DataManagementPlanOverviewModel fromDataModel(DmpEntity entity) {
        this.id = entity.getId().toString();
        this.label = entity.getLabel();
        this.groupId = entity.getGroupId();
        this.status = entity.getStatus().getValue();
//        if (entity.getResearchers() != null) { //TODO
//            this.researchers = entity.getResearchers().stream().map(item -> new Researcher().fromDataModel(item)).collect(Collectors.toList());
//        }
//        if(entity.getDois() != null){
//            this.dois = entity.getDois().stream().map(item -> new Doi().fromDataModel(item)).collect(Collectors.toList());
//        }
        return this;
    }

    public DataManagementPlanOverviewModel fromDataModelDatasets(DmpEntity entity) {
        this.fromDataModel(entity);
        this.version = entity.getVersion();
//        if (entity.getGrant() != null) this.grant = new GrantOverviewModel().fromDataModel(entity.getGrant());
//        if (entity.getProfile() != null) this.profile = entity.getProfile().getLabel();
        this.creationTime = Date.from(entity.getCreatedAt());
        this.modifiedTime = Date.from(entity.getUpdatedAt());
        this.finalizedAt =  Date.from(entity.getFinalizedAt());
//        this.organisations = entity.getOrganisations().stream().map(item -> new Organisation().fromDataModel(item)).collect(Collectors.toList());
//        this.datasets = entity.getDataset().stream().filter(dataset -> !dataset.getIsActive().equals(IsActive.Inactive) && !dataset.getStatus().equals(DescriptionStatus.Canceled)).map(x-> new DatasetOverviewModel().fromDataModel(x)).collect(Collectors.toList());
//        this.users = entity.getUsers().stream().map(x -> new UserInfoListingModel().fromDataModel(x)).collect(Collectors.toList());
//        this.description = entity.getDescription();
//        if (entity.getResearchers() != null) {
//            this.researchers = entity.getResearchers().stream().map(item -> new Researcher().fromDataModel(item)).collect(Collectors.toList());
//        }
//
//        if (entity.getAssociatedDmps() != null && !entity.getAssociatedDmps().isEmpty()) {
//            this.associatedProfiles = new LinkedList<>();
//            for (DMPDatasetProfile dmpDescriptionProfile : entity.getAssociatedDmps()) {
//                AssociatedProfile associatedProfile = new AssociatedProfile().fromData(dmpDescriptionProfile.getDatasetprofile());
//                try {
//                    associatedProfile.setData(new ObjectMapper().readValue(dmpDescriptionProfile.getData(), new TypeReference<Map<String, Object>>() {}));
//                }
//                catch (Exception e) {
//                    associatedProfile.setData(null);
//                }
//                this.associatedProfiles.add(associatedProfile);
//            }
//        }
//        this.isPublic = entity.isPublic();
//        this.publishedAt = entity.getPublishedAt();
//        if (entity.getDois() != null) {
//            this.dois = entity.getDois().stream().map(item -> new Doi().fromDataModel(item)).collect(Collectors.toList());
//        } else {
//            this.dois = new ArrayList<>();
//        }

        return this;
    }

    @Override
    public DmpEntity toDataModel() {
        return null;
    }

    @Override
    public String getHint() {
        return "dataManagementPlanOverviewModel";
    }
}
