package eu.eudat.models.data.listingmodels;

import eu.eudat.commons.enums.DescriptionStatus;
import eu.eudat.data.DescriptionEntity;
import eu.eudat.model.DmpUser;
import eu.eudat.models.DataModel;
import eu.eudat.models.data.datasetprofile.DatasetProfileOverviewModel;

import java.time.Instant;
import java.util.List;


public class DatasetListingModel implements DataModel<DescriptionEntity, DatasetListingModel> {
    private String id;
    private String label;
    private String grant;
    private String dmp;
    private String dmpId;
    private DatasetProfileOverviewModel profile;
    private DescriptionStatus status;
    private Instant created;
    private Instant modified;
    private String description;
    private Instant finalizedAt;
    private Instant dmpPublishedAt;
    private int version;
    private List<DmpUser> users;
    private Boolean isPublic;

    public String getId() {
        return id;
    }
    public void setId(String id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }
    public void setLabel(String label) {
        this.label = label;
    }

    public String getGrant() {
        return grant;
    }
    public void setGrant(String grant) {
        this.grant = grant;
    }

    public String getDmp() {
        return dmp;
    }
    public void setDmp(String dmp) {
        this.dmp = dmp;
    }

    public String getDmpId() {
        return dmpId;
    }
    public void setDmpId(String dmpId) {
        this.dmpId = dmpId;
    }

    public DatasetProfileOverviewModel getProfile() {
        return profile;
    }

    public void setProfile(DatasetProfileOverviewModel profile) {
        this.profile = profile;
    }

    public DescriptionStatus getStatus() {
        return status;
    }
    public void setStatus(DescriptionStatus status) {
        this.status = status;
    }

    public Instant getCreated() {
        return created;
    }
    public void setCreated(Instant created) {
        this.created = created;
    }

    public Instant getModified() {
        return modified;
    }
    public void setModified(Instant modified) {
        this.modified = modified;
    }

    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }

    public Instant getFinalizedAt() {
        return finalizedAt;
    }
    public void setFinalizedAt(Instant finalizedAt) {
        this.finalizedAt = finalizedAt;
    }

    public Instant getDmpPublishedAt() {
        return dmpPublishedAt;
    }
    public void setDmpPublishedAt(Instant dmpPublishedAt) {
        this.dmpPublishedAt = dmpPublishedAt;
    }

    public int getVersion() {
        return version;
    }
    public void setVersion(int version) {
        this.version = version;
    }

    public List<DmpUser> getUsers() {
        return users;
    }

    public void setUsers(List<DmpUser> users) {
        this.users = users;
    }

    public Boolean getPublic() {
        return isPublic;
    }

    public void setPublic(Boolean aPublic) {
        isPublic = aPublic;
    }

    @Override
    public DatasetListingModel fromDataModel(DescriptionEntity entity) {
        //TODO Implement it on transfer
//        this.id = entity.getId() != null ? entity.getId().toString() : "";
//        this.label = entity.getLabel();
//        this.created = entity.getCreatedAt();
//        this.modified = entity.getUpdatedAt();
//        this.grant = (entity.getDmp() != null && entity.getDmp().getGrant() != null) ? entity.getDmp().getGrant().getLabel() : "";
//        this.dmp = entity.getDmp() != null ? entity.getDmp().getLabel() : "";
//        this.dmpId = entity.getDmp() != null ? entity.getDmp().getId().toString() : "";
//        this.profile = entity.getProfile() != null ? new DatasetProfileOverviewModel().fromDataModel(entity.getProfile()) : null;
//        this.description = entity.getDescription();
//        this.status = entity.getStatus();
//        if (entity.getFinalizedAt() == null && entity.getStatus() == DescriptionStatus.Finalized) {
//            this.finalizedAt = entity.getDmp().getFinalizedAt();
//        } else {
//            this.finalizedAt = entity.getFinalizedAt();
//        }
//        this.dmpPublishedAt = entity.getDmp().getPublishedAt();
//        this.version = entity.getDmp().getVersion();
//        this.users = entity.getDmp() != null ? entity.getDmp().getUsers().stream().map(x -> new UserInfoListingModel().fromDataModel(x)).collect(Collectors.toList()) : new ArrayList<>();
//        this.isPublic = entity.getDmp() != null ? entity.getDmp().isPublic() : false;
        return this;
    }

    @Override
    public DescriptionEntity toDataModel() {
        //TODO Implement it on transfer
        DescriptionEntity entity = new DescriptionEntity();
//        entity.setId(UUID.fromString(this.getId()));
//        entity.setLabel(this.getLabel());
//        entity.setCreatedAt(this.getCreated());
//        entity.setUpdatedAt(this.getModified());
//        entity.setDescription(this.getDescription());
//        entity.setFinalizedAt(this.getFinalizedAt());
//        entity.setStatus(this.getStatus());
//        DMP dmp = new DMP();
//        if (this.getGrant() != null && !this.getGrant().isEmpty()) {
//            Grant grant = new Grant();
//            grant.setLabel(this.getGrant());
//            dmp.setGrant(grant);
//        }
//        dmp.setLabel(this.getDmp());
//        dmp.setId(UUID.fromString(this.getDmpId()));
//        dmp.setPublishedAt(this.getDmpPublishedAt());
//        dmp.setVersion(this.getVersion());
//        dmp.setUsers(this.getUsers().stream().map(UserInfoListingModel::toDataModel).collect(Collectors.toSet()));
//        dmp.setPublic(this.getPublic());
//        dmp.setFinalizedAt(this.getFinalizedAt());
//        entity.setDmp(dmp);
//        entity.setProfile(this.getProfile() != null ? this.getProfile().toDataModel() : null);
        return entity;
    }

    @Override
    public String getHint() {
        return "datasetListingModel";
    }
}
