﻿import { Component, Input, OnInit } from '@angular/core';
import { UntypedFormArray, UntypedFormGroup } from '@angular/forms';
import { DescriptionTemplateAutoCompleteFieldEditorModel } from '../../../description-template-editor.model';

@Component({
	selector: 'app-description-template-editor-auto-complete-field-component',
	styleUrls: ['./description-template-editor-auto-complete-field.component.scss'],
	templateUrl: './description-template-editor-auto-complete-field.component.html'
})
export class DescriptionTemplateEditorAutoCompleteFieldComponent implements OnInit {

	@Input() form: UntypedFormGroup;
	multiForm: UntypedFormArray;

	ngOnInit() {
		this.multiForm = (<UntypedFormArray>this.form.get('data').get('autoCompleteSingleDataList'));
	}

	addSource() {
		(<UntypedFormArray>this.multiForm).push(new DescriptionTemplateAutoCompleteFieldEditorModel().buildForm());
	}

	removeSource(index: number) {
		(<UntypedFormArray>this.multiForm).removeAt(index);
	}
}
