import { NgModule } from '@angular/core';
import { FormattingModule } from "@app/core/formatting.module";
import { AutoCompleteModule } from '@app/library/auto-complete/auto-complete.module';
import { RichTextEditorModule } from "@app/library/rich-text-editor/rich-text-editor.module";
import { CommonFormsModule } from '@common/forms/common-forms.module';
import { CommonUiModule } from '@common/ui/common-ui.module';
import { NgxDropzoneModule } from "ngx-dropzone";
import { DescriptionFormCompositeTitleComponent } from './components/form-composite-title/form-composite-title.component';
import { DescriptionFormFieldSetComponent } from './components/form-field-set/form-field-set.component';
import { DescriptionFormFieldComponent } from './components/form-field/form-field.component';
import { DescriptionFormSectionComponent } from './components/form-section/form-section.component';
import { DescriptionFormComponent } from './description-form.component';


@NgModule({
	imports: [
		CommonUiModule,
		CommonFormsModule,
		AutoCompleteModule,
		RichTextEditorModule,
		NgxDropzoneModule,
		FormattingModule
	],
	declarations: [
		DescriptionFormComponent,
		DescriptionFormSectionComponent,
		DescriptionFormFieldSetComponent,
		DescriptionFormFieldComponent,
		DescriptionFormCompositeTitleComponent
	],
	exports: [
		DescriptionFormComponent
	],
	providers: [
	]
})
export class DescriptionFormModule { }

