import { NgModule } from '@angular/core';
import { ArrayToStringPipe } from '@common/formatting/pipes/array-to-string.pipe';
import { DataTableDateFormatPipe, DateFormatPipe } from '@common/formatting/pipes/date-format.pipe';
import { DataTableDateOnlyFormatPipe, DateOnlyPipe } from '@common/formatting/pipes/date-only-format.pipe';
import { DataTableDateTimeFormatPipe, DateTimeFormatPipe } from '@common/formatting/pipes/date-time-format.pipe';
import { LowercaseFirstLetterPipe } from '@common/formatting/pipes/lowercase-first-letter.pipe';
import { IsActiveTypePipe } from './pipes/is-active-type.pipe';
import { ReferenceTypePipe } from './pipes/reference-type.pipe';
import { ReferenceSourceTypePipe } from './pipes/reference-source-type.pipe';
import { NotificationTemplateChannelPipe } from './pipes/notification-template-channel.pipe';
import { NotificationTemplateKindPipe } from './pipes/notification-template-kind.pipe';

//
//
// This is shared module that provides all formatting utils. Its imported only once on the AppModule.
//
//
@NgModule({
	declarations: [
		DateFormatPipe,
		DateTimeFormatPipe,
		DataTableDateFormatPipe,
		DataTableDateTimeFormatPipe,
		LowercaseFirstLetterPipe,
		ArrayToStringPipe,
		DateOnlyPipe,
		DataTableDateOnlyFormatPipe,
		IsActiveTypePipe,
		ReferenceTypePipe,
		ReferenceSourceTypePipe,
		NotificationTemplateChannelPipe,
		NotificationTemplateKindPipe
	],
	exports: [
		DateFormatPipe,
		DateTimeFormatPipe,
		DataTableDateFormatPipe,
		DataTableDateTimeFormatPipe,
		LowercaseFirstLetterPipe,
		ArrayToStringPipe,
		DateOnlyPipe,
		DataTableDateOnlyFormatPipe,
		IsActiveTypePipe,
		ReferenceTypePipe,
		ReferenceSourceTypePipe,
		NotificationTemplateChannelPipe,
		NotificationTemplateKindPipe
	],
	providers: [
		DateFormatPipe,
		DateTimeFormatPipe,
		DataTableDateFormatPipe,
		DataTableDateTimeFormatPipe,
		LowercaseFirstLetterPipe,
		ArrayToStringPipe,
		DateOnlyPipe,
		DataTableDateOnlyFormatPipe,
		IsActiveTypePipe,
		ReferenceTypePipe,
		ReferenceSourceTypePipe,
		NotificationTemplateChannelPipe,
		NotificationTemplateKindPipe
	]
})
export class CommonFormattingModule { }
